LibreOffice: InteractionHandler Service Reference

LibreOffice LibreOffice 7.5 SDK API Reference

Loading...
Searching...
No Matches
Public Member Functions | List of all members
InteractionHandler Service Referencepublished

An interaction request handler that lets the user handle requests via GUI dialogs. More...

Inheritance diagram for InteractionHandler:

## Public Member Functions
| createWithParent ([in] com::sun::star::awt::XWindow parent)
| Creates an instance.
| createWithParentAndContext ([in] com::sun::star::awt::XWindow parent, [in] string context)
| Creates an instance with an additional context.
Public Member Functions inherited from XInteractionHandler2
boolean | handleInteractionRequest ([in] com::sun::star::task::XInteractionRequest Request)
| Handle an interaction request.
Public Member Functions inherited from XInteractionHandler
void | handle ([in] com::sun::star::task::XInteractionRequest Request)
| Handle an interaction request.
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.

## Detailed Description

An interaction request handler that lets the user handle requests via GUI dialogs.

The interaction handler service has a number of built-in handlers, responsible for a lot of well known interactions. Additionally, there's a configuration module which allows to configure additional handlers, responsible for arbitrary requests.

### Built-in Handlers

The following well-known requests can be dealt with by the built-in handlers:

- com::sun::star::ucb::AuthenticationRequest
- com::sun::star::ucb::CertificateValidationRequest
- com::sun::star::ucb::InteractiveAugmentedIOException*
- com::sun::star::ucb::InteractiveFileIOException*
- com::sun::star::ucb::InteractiveIOException*
- com::sun::star::ucb::InteractiveNetworkConnectException*
- com::sun::star::ucb::InteractiveNetworkException*
- com::sun::star::ucb::InteractiveNetworkGeneralException*
- com::sun::star::ucb::InteractiveNetworkOffLineException*
- com::sun::star::ucb::InteractiveNetworkReadException*
- com::sun::star::ucb::InteractiveNetworkResolveNameException*
- com::sun::star::ucb::InteractiveNetworkWriteException*
- com::sun::star::ucb::InteractiveWrongMediumException*
- com::sun::star::task::PasswordRequest
- com::sun::star::java::WrongJavaVersionException*
- com::sun::star::task::DocumentMacroConfirmationRequest

The requests marked with an asterisk are only handled if (a) their continuations match certain restrictions (see below), and (b) the necessary resource strings are available (this can be exploited by applications that carry only a subset of all resource files with them).

The continuation restrictions are as follows: Let C be the subset of the provided continuations that are of type com::sun::star::task::XInteractionApprove, com::sun::star::task::XInteractionDisapprove, com::sun::star::task::XInteractionRetry, or com::sun::star::task::XInteractionAbort (or of a derived type). All other continuations are ignored for these requests. The request is only handled if the set C is any of the following:

- Abort
- Retry, Abort
- Approve
- Approve, Abort
- Approve, Disapprove
- Approve, Disapprove, Abort

An com::sun::star::ucb::InteractiveAugmentedIOException carries with it a sequence of arguments, which should be com::sun::star::beans::PropertyValues. The following details which properties are interpreted by the interaction handler, depending on the request's com::sun::star::ucb::IOErrorCode:

`"Uri"`

  All error codes except com::sun::star::ucb::IOErrorCode::DIFFERENT_DEVICES. The URI of the involved resource (a `string`).

`"ResourceName"`

  All error codes except com::sun::star::ucb::IOErrorCode::DIFFERENT_DEVICES. A name for the involved resource (a `string`) that might be more meaningful to the user than the URI. For example, a (platform-dependent) path notation for file system resources.

`"ResourceType"`

  com::sun::star::ucb::IOErrorCode::DEVICE_NOT_READY and com::sun::star::ucb::IOErrorCode::NOT_EXISTING only. An identifier for the type of resource involved (a `string`). Currently understood values are `"volume"` (e.g., a file system volume) and `"folder"` (i.e., a resource that contains other resources).

`"Removable"`

  com::sun::star::ucb::IOErrorCode::NOT_EXISTING only. A flag indicating whether the resource resides on a storage medium that can be removed by the user (a `boolean`).

`"Folder"`

  com::sun::star::ucb::IOErrorCode::CANT_CREATE only. The name of the folder in which a resource cannot be created (a `string`).

`"Volume"` and `"OtherVolume"`
  com::sun::star::ucb::IOErrorCode::DIFFERENT_DEVICES only. The names of the two volumes involved (two `string`s).

### Configuring additional Handlers

It is possible to configure additional interaction handlers, to which certain requests can be delegated. The configuration node `/org.openoffice.Interaction/InteractionHandlers` is evaluated and respected by the `InteractionHandler` implementation.

A custom interaction handler can declare itself responsible for an arbitrary number of UNO types, specified by full-qualified type name. Also, for each type, it can specify whether it is responsible for only this particular type, or all possibly existent derived types.

Whenever the `InteractionHandler` encounters a request it cannot fulfill itself, it will examine the configuration, to find a handler implementation for the request, and delegate it to the first matching handler.

If multiple custom interaction handlers declare themselves responsible for the same request type, it is not defined which handler will actually be invoked. Thus, when deploying a custom interaction handler, ensure that the types you specify are general enough to cover all requests you want to handle, but also specific enough to not cover requests which other handlers might be interested in.

## Member Function Documentation

## ◆ createWithParent()

createWithParent | ( | [in] com::sun::star::awt::XWindow | parent | ) |

Creates an instance.

Parameters

  parent | denotes the parent window for any GUI dialogs the interaction handler pops up; may be null.

## ◆ createWithParentAndContext()

createWithParentAndContext | ( | [in] com::sun::star::awt::XWindow | parent,
|  | [in] string | context
| ) |  |

Creates an instance with an additional context.

Parameters

  parent | denotes the parent window for any GUI dialogs the interaction handler pops up; may be null.
  context | is a textual description of the current context (used, e.g., as a first line of text in error boxes).

The documentation for this service was generated from the following file:

- com/sun/star/task/InteractionHandler.idl